A YANG Data Model for Segment Routing (SR) Policy and SR in IPv6 (SRv6) support in Path Computation Element Communications Protocol (PCEP)
Cheng Li
Huawei Technologies
Huawei Campus, No. 156 Beiqing Rd.
Beijing
100095
China
c.l@huawei.com
Siva Sivabalan
Ciena Corporation
ssivabal@ciena.com
Shuping Peng
Huawei Technologies
Huawei Campus, No. 156 Beiqing Rd.
Beijing
100095
China
pengshuping@huawei.com
Mike Koldychev
Cisco Systems, Inc.
mkoldych@cisco.com
Luc-Fabrice Ndifor
MTN Cameroon
Cameroon
Luc-Fabrice.Ndifor@mtn.com
Routing
PCE Working Group
This document augments a YANG data model for the management of Path Computation Element Communications Protocol (PCEP) for communications between a Path Computation Client (PCC) and a Path Computation Element (PCE), or between two PCEs in support for Segment Routing in IPv6 (SRv6) and SR Policy. The data model includes configuration data and state data (status information and counters for the collection of statistics).

Introduction
The Path Computation Element (PCE) defined in [RFC4655] is an entity that is capable of computing a network path or route based on a network graph, and applying computational constraints. A Path Computation Client (PCC) may make requests to a PCE for paths to be computed.
PCEP is the communication protocol between a PCC and PCE and is defined in [RFC5440]. PCEP interactions include path computation requests and path computation replies as well as notifications of specific states related to the use of a PCE in the context of Multiprotocol Label Switching (MPLS) and Generalized MPLS (GMPLS) Traffic Engineering (TE). [RFC8231] specifies extensions to PCEP to enable stateful control of MPLS TE LSPs.
[I-D.ietf-pce-segment-routing-ipv6] extends [RFC8664] to support SR for IPv6 data plane.
[I-D.ietf-pce-pcep-yang] defines a YANG [RFC7950] data model for the management of PCEP speakers. This document contains a specification of the PCEP-SRv6 YANG module, "ietf-pcep-srv6" which provides the PCEP-SRv6 [I-D.ietf-pce-segment-routing-ipv6] data model. This document also contains the PCEP SR Policy YANG module, "ietf-pcep-srpolicy" which provides a reference to SR Policies [I-D.ietf-spring-segment-routing-policy].
The PCEP operational state is included in the same tree as the PCEP configuration consistent with Network Management Datastore Architecture (NMDA) [RFC8342]. The origin of the data is indicated as per the origin metadata annotation.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Terminology and Notation
This document also uses the following terms defined in [RFC7420]:
- PCEP entity: a local PCEP speaker.
- PCEP peer: a remote PCEP speaker.
- PCEP speaker: where it is not necessary to distinguish between local and remote.
Further, this document also uses the following terms defined in [RFC8231] :
- Stateful PCE, Passive Stateful PCE, Active Stateful PCE.
- Delegation, Revocation, Redelegation.
- LSP State Report, Path Computation Report message (PCRpt).
- LSP State Update, Path Computation Update message (PCUpd).
[RFC8281] :
- PCE-initiated LSP, Path Computation LSP Initiate Message (PCInitiate).
[RFC8408] :
- Path Setup Type (PST).
[RFC8664] :
- Segment Routing (SR).
[I-D.ietf-pce-segment-routing-ipv6] :
- Segment Routing in IPv6 (SRv6).
[I-D.ietf-spring-segment-routing-policy] :
- SR Policy.

Tree Diagrams
A simplified graphical representation of the data model is used in this document. The meaning of the symbols in these diagrams is defined in [RFC8340].

Prefixes in Data Node Names
In this document, names of data nodes and other data model objects are often used without a prefix, as long as it is clear from the context in which YANG module each name is defined. Otherwise, names are prefixed using the standard prefix associated with the corresponding YANG module, as shown in Table 1.

Prefixes and corresponding YANG modules
Prefix | YANG module | Reference
inet | ietf-inet-types | [RFC6991]
te-types | ietf-te-types | [RFC8776]
pcep | ietf-pcep | [I-D.ietf-pce-pcep-yang]
srv6-types | ietf-srv6-types | [I-D.ietf-spring-srv6-yang]
sr-policy-types | ietf-sr-policy-types | [I-D.ietf-spring-sr-policy-yang]

References in the Model
Following additional documents are referenced in the model defined in this document -

References in the YANG modules
Title | Reference
PCEP Extensions for Segment Routing leveraging the IPv6 data plane | [I-D.ietf-pce-segment-routing-ipv6]
Carrying Binding Label/Segment Identifier (SID) in PCE-based Networks | [I-D.ietf-pce-binding-label-sid]
Segment Routing Policy Architecture | [I-D.ietf-spring-segment-routing-policy]
PCEP Extensions for Signaling Multipath Information | [I-D.ietf-pce-multipath]

Further Discussion
[I-D.ietf-pce-multipath] defines a mechanism to encode multiple paths for a single set of objectives and constraints. This is a generic PCEP mechanism, not specific to any path setup type or dataplane but the key usecase is SR.
Further discussion is needed on how to model it in PCEP YANG.

The Design of YANG Data Model

The Overview of PCEP SRv6 Data Model
The PCEP-SRv6 YANG module defined in this document has all the common building blocks for the PCEP-SRv6 extension. The model augments PCEP capabilities at the Entity and peer level with SRv6 capability in PCEP, support for NAI, MSD and the SID structure. The model also extends the LSP in the LSP-DB to maintain SRv6 paths.

module: ietf-pcep-srv6

  augment /pcep:pcep/pcep:entity/pcep:capabilities:
    +--rw srv6 {srv6}?
    |  +--rw enabled?     boolean
    |  +--rw nai?         boolean
    |  +--rw msd-limit?   boolean
    |  +--rw srv6-msd* [msd-type]
    |     +--rw msd-type     uint8
    |     +--rw msd-value?   uint8
    +--rw sid-str {sid-str}?
       +--rw lb?   uint8
       +--rw ln?   uint8
       +--rw fn?   uint8
       +--rw an?   uint8
  augment /pcep:pcep/pcep:entity/pcep:peers/pcep:peer
            /pcep:capabilities:
    +--rw srv6 {srv6}?
       +--rw enabled?     boolean
       +--rw nai?         boolean
       +--rw msd-limit?   boolean
       +--rw srv6-msd* [msd-type]
          +--rw msd-type     uint8
          +--rw msd-value?   uint8
  augment /pcep:pcep/pcep:entity/pcep:lsp-db/pcep:lsp:
    +--ro srv6 {srv6}?
       +--ro segment-list
          +--ro segment* [index]
             +--ro index                uint32
             +--ro sid-value?           srv6-types:srv6-sid
             +--ro sid-str {sid-str}?
             |  +--ro lb?   uint8
             |  +--ro ln?   uint8
             |  +--ro fn?   uint8
             |  +--ro an?   uint8
             +--ro endpoint-behavior?   identityref

The Overview of PCEP SR Policy Data Model
The PCEP-SRPolicy YANG module defined in this document has all the common building blocks for the PCEP-SR Policy extension. The model augments the LSP in the LSPDB to have information refering to the SR Policy and the candidate path.

module: ietf-pcep-srpolicy

  augment /pcep:pcep/pcep:entity/pcep:lsp-db/pcep:lsp:
    +--ro sr-policy
       +--ro headend?           inet:ip-address-no-zone
       +--ro color?             uint32
       +--ro endpoint?          inet:ip-address-no-zone
       +--ro protocol-origin?   sr-policy-types:protocol-origin-type
       +--ro originator?        string
       +--ro discriminator?     uint32

The sr-policy container is applicable for both SR-MPLS and SRv6.

The YANG Modules

ietf-pcep-srv6 module
RFC Ed.: In this section, replace all occurrences of 'XXXX' with the actual RFC number and all occurrences of the revision date below with the date of RFC publication (and remove this note).

<CODE BEGINS> file "ietf-pcep-srv6@2022-07-11.yang"
module ietf-pcep-srv6 {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:ietf-pcep-srv6";
  prefix pcep-srv6;

  import ietf-srv6-types {
    prefix srv6-types;
    reference
      "I-D.ietf-spring-srv6-yang: YANG Data Model for SRv6
       Base and Static";
  }
  import ietf-te-types {
    prefix te-types;
    reference
      "RFC 8776: Common YANG Data Types for Traffic Engineering";
  }
  import ietf-pcep {
    prefix pcep;
    reference
      "I-D.ietf-pce-pcep-yang: A YANG Data Model for Path
       Computation Element Communications Protocol (PCEP)";
  }

  organization
    "IETF PCE (Path Computation Element) Working Group";
  contact
    "WG Web:   <https://datatracker.ietf.org/wg/pce/>
     WG List:  <mailto:pce@ietf.org>
     Editor:   Cheng Li
               <mailto:c.l@huawei.com>
               Shuping Peng
               <mailto:pengshuping@huawei.com>";
  description
    "The YANG module augments the Path Computation Element
     Communications Protocol (PCEP) YANG operational model
     with Segment Routing in IPv6 (SRv6).

     Copyright (c) 2022 IETF Trust and the persons identified as
     authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or
     without modification, is permitted pursuant to, and subject
     to the license terms contained in, the Revised BSD License
     set forth in Section 4.c of the IETF Trust's Legal Provisions
     Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC XXXX; see the
     RFC itself for full legal notices.";

  revision 2022-07-11 {
    description
      "Initial revision.";
    reference
      "RFC XXXX:  A YANG Data Model for Segment Routing (SR) Policy
       and SRv6 support in Path Computation Element Communications
       Protocol (PCEP)";
  }

  /* Features */

  feature srv6 {
    description
      "Support Segment Routing in IPv6 (SRv6) for PCE.";
    reference
      "I-D.ietf-pce-segment-routing-ipv6: PCEP Extensions
       for Segment Routing leveraging the IPv6 data plane";
  }

  feature bsid {
    description
      "Support Binding SID for PCE.";
    reference
      "I-D.ietf-pce-binding-label-sid: Carrying Binding
       Label/Segment Identifier (SID) in PCE-based Networks.";
  }

  feature sid-str {
    description
      "Support for SID Structure";
    reference
      "I-D.ietf-pce-segment-routing-ipv6: PCEP Extensions
       for Segment Routing leveraging the IPv6 data plane";
  }

  /* Identity */

  identity path-setup-srv6 {
    if-feature "srv6";
    base te-types:path-signaling-type;
    description
      "SRv6 path setup type";
  }

  /* Groupings */

  grouping srv6-msd {
    description
      "SRv6 MSD";
    leaf msd-type {
      type uint8;
      description
        "SRv6 Maximum Segment Depth (MSD) Type";
    }
    leaf msd-value {
      type uint8;
      description
        "SRv6 MSD value for the type";
    }
    reference
      "I-D.ietf-pce-segment-routing-ipv6: PCEP Extensions
       for Segment Routing leveraging the IPv6 data plane";
  }

  grouping srv6 {
    description
      "SRv6";
    container srv6 {
      if-feature "srv6";
      description
        "If SRv6 is supported";
      leaf enabled {
        type boolean;
        description
          "Enabled or Disabled; set to true when
           Enabled";
      }
      leaf nai {
        type boolean;
        default "false";
        description
          "True indicates capability to resolve Node or
           Adjacency Identifier (NAI) to SRv6 Segment
           Identifier (SID)";
      }
      leaf msd-limit {
        type boolean;
        default "false";
        description
          "True indicates no limit on MSD, the
           list srv6-msd is ignored";
      }
      list srv6-msd {
        key "msd-type";
        description
          "list of SRv6 MSD";
        uses srv6-msd;
      }
    }
  }

  grouping segment-list {
    description
      "Segment list grouping";
    container segment-list {
      description
        "Segments for given segment list";
      list segment {
        key "index";
        description
          "Configure Segment/hop at the index";
        uses segment-properties;
      }
    }
  }

  grouping segment-properties {
    description
      "Segment properties grouping";
    leaf index {
      type uint32;
      description
        "Segment index";
    }
    leaf sid-value {
      type srv6-types:srv6-sid;
      description
        "SRv6 SID value";
    }
    uses sid-str;
    leaf endpoint-behavior {
      type identityref {
        base srv6-types:srv6-endpoint-type;
      }
      description
        "The behavior associated with the SRv6 SIDs.";
    }
    /*Query: Add NAI?*/
  }

  grouping sid-str {
    description
      "The default SID Structure";
    container sid-str {
      if-feature "sid-str";
      description
        "The default SID Structure";
      leaf lb {
        type uint8;
        description
          "SRv6 SID Locator Block length in bits";
      }
      leaf ln {
        type uint8;
        description
          "SRv6 SID Locator Node length in bits";
      }
      leaf fn {
        type uint8;
        description
          "SRv6 SID Function length in bits";
      }
      leaf an {
        type uint8;
        description
          "SRv6 SID Arguments length in bits";
      }
    }
  }

  /*
   * Augment modules to add SRv6
   */

  augment "/pcep:pcep/pcep:entity/pcep:capabilities" {
    description
      "Augmenting SRv6";
    uses srv6;
    uses sid-str;
  }

  augment "/pcep:pcep/pcep:entity/pcep:peers/pcep:peer"
        + "/pcep:capabilities" {
    description
      "Augmenting SRv6";
    uses srv6;
  }

  augment "/pcep:pcep/pcep:entity/pcep:lsp-db/pcep:lsp" {
    description
      "Augmenting SRv6";
    container srv6 {
      when
        "derived-from-or-self
         (/pcep:pcep/pcep:entity/pcep:lsp-db/pcep:lsp/pcep:pst,
          'path-setup-srv6')" {
        description
          "For SRv6 path";
      }
      if-feature "srv6";
      uses segment-list;
      description
        "SRv6";
    }
  }
}

<CODE ENDS>

ietf-pcep-srpolicy module
RFC Ed.: In this section, replace all occurrences of 'XXXX' with the actual RFC number and all occurrences of the revision date below with the date of RFC publication (and remove this note).

<CODE BEGINS> file "ietf-pcep-srpolicy@2022-07-11.yang"
module ietf-pcep-srpolicy {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:ietf-pcep-srpolicy";
  prefix pcep-srp;

  import ietf-inet-types {
    prefix inet;
    reference
      "RFC 6991: Common YANG Data Types";
  }
  import ietf-pcep {
    prefix pcep;
    reference
      "I-D.ietf-pce-pcep-yang: A YANG Data Model for Path
       Computation Element Communications Protocol (PCEP)";
  }
  import ietf-sr-policy-types {
    prefix sr-policy-types;
    reference
      "I-D.ietf-spring-sr-policy-yang: YANG Data Model for
       Segment Routing Policy";
  }

  organization
    "IETF PCE (Path Computation Element) Working Group";
  contact
    "WG Web:   <https://datatracker.ietf.org/wg/pce/>
     WG List:  <mailto:pce@ietf.org>
     Editor:   Cheng Li
               <mailto:c.l@huawei.com>
               Shuping Peng
               <mailto:pengshuping@huawei.com>";
  description
    "The YANG module augments the Path Computation Element
     Communications Protocol (PCEP) YANG model with Segment
     Routing (SR) Policy.

     Copyright (c) 2022 IETF Trust and the persons identified as
     authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or
     without modification, is permitted pursuant to, and subject
     to the license terms contained in, the Revised BSD License
     set forth in Section 4.c of the IETF Trust's Legal Provisions
     Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC XXXX; see the
     RFC itself for full legal notices.";

  revision 2022-07-11 {
    description
      "Initial revision.";
    reference
      "RFC XXXX:  A YANG Data Model for Segment Routing (SR) Policy
       and SRv6 support in Path Computation Element Communications
       Protocol (PCEP)";
  }

  /* Features */

  feature multipath {
    description
      "Support for multipath ERO.";
    reference
      "I-D.ietf-pce-multipath: PCEP Extensions for Signaling
       Multipath Information";
  }

  /* Groupings */

  grouping sr-policy {
    description
      "Segment Routing Policy grouping";
    leaf headend {
      type inet:ip-address-no-zone;
      description
        "SR Policy headend";
      reference
        "I-D.ietf-spring-segment-routing-policy: Segment
         Routing Policy Architecture";
    }
    leaf color {
      type uint32 {
        range "1..max";
      }
      description
        "SR Policy Color";
      reference
        "I-D.ietf-spring-segment-routing-policy: Segment
         Routing Policy Architecture";
    }
    leaf endpoint {
      type inet:ip-address-no-zone;
      description
        "SR Policy Endpoint";
      reference
        "I-D.ietf-spring-segment-routing-policy: Segment
         Routing Policy Architecture";
    }
  }

  grouping sr-policy-cp {
    description
      "Segment Routing Policy Candidate Path grouping";
    leaf protocol-origin {
      type sr-policy-types:protocol-origin-type;
      description
        "SR Policy Candidate Path Protocol";
      reference
        "I-D.ietf-spring-segment-routing-policy: Segment
         Routing Policy Architecture";
    }
    leaf originator {
      type string;
      description
        "SR Policy Candidate Path Originator";
      reference
        "I-D.ietf-spring-segment-routing-policy: Segment
         Routing Policy Architecture";
    }
    leaf discriminator {
      type uint32 {
        range "1..max";
      }
      description
        "SR Policy Candidate Path Discriminator";
      reference
        "I-D.ietf-spring-segment-routing-policy: Segment
         Routing Policy Architecture";
    }
  }

  augment "/pcep:pcep/pcep:entity/pcep:lsp-db/pcep:lsp" {
    description
      "Augmenting SR Policy";
    container sr-policy {
      when
        "derived-from-or-self
         (/pcep:pcep/pcep:entity/pcep:lsp-db/pcep:lsp/pcep:pst,
          'path-setup-sr') or
         derived-from-or-self
         (/pcep:pcep/pcep:entity/pcep:lsp-db/pcep:lsp/pcep:pst,
          'path-setup-srv6')" {
        description
          "Applicable for SR or SRv6";
      }
      uses sr-policy;
      uses sr-policy-cp;
      description
        "SR Policy Candidate Path";
    }
  }
}

<CODE ENDS>

Security Considerations
The YANG module defined in this document is designed to be accessed via network management protocol such as NETCONF [RFC6241] or RESTCONF [RFC8040]. The lowest NETCONF layer is the secure transport layer and the mandatory-to-implement secure transport is SSH [RFC6242]. The lowest RESTCONF layer is HTTPS, and the mandatory-to-implement secure transport is TLS [RFC8446]
The NETCONF access control model [RFC8341] provides the means to restrict access for particular NETCONF or RESTCONF users to a pre-configured subset of all available NETCONF or RESTCONF protocol operations and content.
There are a number of data nodes defined in the YANG module which are writable/creatable/deletable (i.e., config true, which is the default). These data nodes may be considered sensitive or vulnerable in some network environments. Write operations (e.g., <edit-config>) to these data nodes without proper protection can have a negative effect on network operations. These are the subtrees and data nodes and their sensitivity/vulnerability:
/pcep:pcep/pcep:entity/pcep:capabilities/pcep-srv6:srv6 - configure local SRv6 capability and parameters.
/pcep:pcep/pcep:entity/pcep:peers/pcep:peer/pcep:capabilities/pcep-srv6:srv6 - configure peer's SRv6 capability and parameters.
Unauthorized access to above list can adversely affect the PCEP session between the local entity and the peers. This may lead to inability to compute new paths, stateful operations on the delegated as well as PCE-initiated LSPs.
Some of the readable data nodes in this YANG module may be considered sensitive or vulnerable in some network environments. It is thus important to control read access (e.g., via get, get-config, or notification) to these data nodes. These are the subtrees and data nodes and their sensitivity/vulnerability:
/pcep:pcep/pcep:entity/pcep:lsp-db/pcep:lsp/pcep-srv6:srv6 - The SRv6 SID in the network. Unauthorized access to this could provide entire path and network usage information.
/pcep:pcep/pcep:entity/pcep:lsp-db/pcep:lsp/pcep-srpolicy:sr-policy - The reference to SR Policy. Unauthorized access to this could provide SR Policy usage information.

IANA Considerations
This document registers a URI in the "IETF XML Registry" [RFC3688]. Following the format in RFC 3688, the following registration has been made.
URI: urn:ietf:params:xml:ns:yang:ietf-pcep-srv6
Registrant Contact: The PCE WG of the IETF.
XML: N/A; the requested URI is an XML namespace.
URI: urn:ietf:params:xml:ns:yang:ietf-pcep-srpolicy
Registrant Contact: The PCE WG of the IETF.
XML: N/A; the requested URI is an XML namespace.
This document registers a YANG module in the "YANG Module Names" registry [RFC6020].

    Name:         ietf-pcep-srv6
    Namespace:    urn:ietf:params:xml:ns:yang:ietf-pcep-srv6
    Prefix:       pcep-srv6
    Reference:    This I-D

    Name:         ietf-pcep-srpolicy
    Namespace:    urn:ietf:params:xml:ns:yang:ietf-pcep-srpolicy
    Prefix:       pcep-srp
    Reference:    This I-D

Acknowledgements
The authors would like to thank Dhruv Dhody for the initial YANG model.

Normative References

Informative References
[RFC4655]
[RFC5440]
[RFC8231]
[I-D.ietf-pce-segment-routing-ipv6]
[RFC8664]
[I-D.ietf-pce-pcep-yang]
[RFC7950]
[I-D.ietf-spring-segment-routing-policy]
[RFC8342]
[RFC2119]
[RFC8174]
[RFC7420]
[RFC8281]
[RFC8408]
[RFC8340]
[RFC6991]
[RFC8776]
[I-D.ietf-spring-srv6-yang]
[I-D.ietf-spring-sr-policy-yang]
[I-D.ietf-pce-binding-label-sid]
[I-D.ietf-pce-multipath]
[RFC6241]
[RFC8040]
[RFC6242]
[RFC8446]
[RFC8341]
[RFC3688]
[RFC6020]